{-# OPTIONS_GHC -w #-}
{-# OPTIONS -fglasgow-exts -cpp #-}
-----------------------------------------------------------------------------
-- |
-- Module      :  LRSX.Interface.Parser
-- Copyright   :  (c) D. Sabel, Goethe-University, Frankfurt a.M., Germany
-- License     :  BSD-style 
-- 
-- Maintainer  :  sabel <at> ki.cs.uni-frankfurt.de
--
--  
-- The Parser of LRSX Unification tool, generated by Happymainly
--
-----------------------------------------------------------------------------
-- 
--
-- other todos:  - add strictness and arity info automatically 
--               - nub funinfo
--               - check that all binding positions are correct
--               - check that strictness information and arities are consistently used
--               - check that no binding position is strict
--               - compute the bindarity
--
module LRSX.Interface.Parser 
where
import LRSX.Interface.Lexer
import LRSX.Language.Syntax 
import Data.List
import LRSX.Unification.UnificationProblem
import LRSX.Diagrams.Rules
import qualified Data.Array as Happy_Data_Array
import qualified GHC.Exts as Happy_GHC_Exts
import Control.Applicative(Applicative(..))
import Control.Monad (ap)

-- parser produced by Happy Version 1.19.5

newtype HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36 = HappyAbsSyn HappyAny
#if __GLASGOW_HASKELL__ >= 607
type HappyAny = Happy_GHC_Exts.Any
#else
type HappyAny = forall a . a
#endif
happyIn9 :: (((([ConstrainedRule],[ConstrainedRule],[ConstrainedRule]),[Command],[Command]),FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> (((([ConstrainedRule],[ConstrainedRule],[ConstrainedRule]),[Command],[Command]),FunInfo))
happyOut9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: ((([ConstrainedRule],[Command]),FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ((([ConstrainedRule],[Command]),FunInfo))
happyOut10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: t11 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t11
happyOut11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: t12 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t12
happyOut12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: t13 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t13
happyOut13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: t14 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t14
happyOut14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: ((([ConstrainedRule],[ConstrainedRule],[ConstrainedRule]),FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ((([ConstrainedRule],[ConstrainedRule],[ConstrainedRule]),FunInfo))
happyOut15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyIn16 :: (([ConstrainedRule],FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn16 #-}
happyOut16 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> (([ConstrainedRule],FunInfo))
happyOut16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut16 #-}
happyIn17 :: (RuleName) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn17 #-}
happyOut17 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> (RuleName)
happyOut17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut17 #-}
happyIn18 :: t18 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn18 #-}
happyOut18 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t18
happyOut18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut18 #-}
happyIn19 :: t19 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn19 #-}
happyOut19 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t19
happyOut19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut19 #-}
happyIn20 :: t20 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn20 #-}
happyOut20 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t20
happyOut20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut20 #-}
happyIn21 :: t21 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn21 #-}
happyOut21 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t21
happyOut21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut21 #-}
happyIn22 :: ((EquationsWithConstraints,FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn22 #-}
happyOut22 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ((EquationsWithConstraints,FunInfo))
happyOut22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut22 #-}
happyIn23 :: (([Equation Expression],FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn23 #-}
happyOut23 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> (([Equation Expression],FunInfo))
happyOut23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut23 #-}
happyIn24 :: t24 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn24 #-}
happyOut24 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t24
happyOut24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut24 #-}
happyIn25 :: ((EquationsWithTwoConstraints,FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn25 #-}
happyOut25 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ((EquationsWithTwoConstraints,FunInfo))
happyOut25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut25 #-}
happyIn26 :: ((Expression,FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn26 #-}
happyOut26 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ((Expression,FunInfo))
happyOut26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut26 #-}
happyIn27 :: ((Expression,FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn27 #-}
happyOut27 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ((Expression,FunInfo))
happyOut27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut27 #-}
happyIn28 :: (([(ArgPos,BindArity)],FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn28 #-}
happyOut28 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> (([(ArgPos,BindArity)],FunInfo))
happyOut28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut28 #-}
happyIn29 :: ((ArgPos,FunInfo,BindArity)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn29 #-}
happyOut29 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ((ArgPos,FunInfo,BindArity))
happyOut29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut29 #-}
happyIn30 :: ((Expression,FunInfo)) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn30 #-}
happyOut30 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ((Expression,FunInfo))
happyOut30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut30 #-}
happyIn31 :: t31 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn31 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn31 #-}
happyOut31 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t31
happyOut31 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut31 #-}
happyIn32 :: t32 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn32 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn32 #-}
happyOut32 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t32
happyOut32 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut32 #-}
happyIn33 :: t33 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn33 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn33 #-}
happyOut33 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t33
happyOut33 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut33 #-}
happyIn34 :: ([Int]) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn34 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn34 #-}
happyOut34 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> ([Int])
happyOut34 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut34 #-}
happyIn35 :: t35 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn35 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn35 #-}
happyOut35 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t35
happyOut35 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut35 #-}
happyIn36 :: t36 -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyIn36 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn36 #-}
happyOut36 :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> t36
happyOut36 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut36 #-}
happyInTok :: (TokenType) -> (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36)
happyInTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn t11 t12 t13 t14 t18 t19 t20 t21 t24 t31 t32 t33 t35 t36) -> (TokenType)
happyOutTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOutTok #-}


happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x6a\x00\x6a\x00\x6a\x00\xf2\xff\xf2\xff\xf2\xff\xf2\xff\x00\x00\xd1\x01\x6a\x00\xf2\xff\x00\x00\x01\x00\x2c\x00\xd0\x01\x6b\x00\xd0\x01\x6b\x00\xd0\x01\xcf\x01\xce\x01\xc9\x01\xcd\x01\x00\x00\x00\x00\x54\x00\x00\x00\xcc\x01\xcb\x01\xca\x01\x51\x00\x3b\x00\x0d\x00\x00\x00\x81\x01\x81\x01\x81\x01\x81\x01\xb8\x01\xb7\x01\xb6\x01\x34\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc3\x01\xb9\x01\xc2\x01\x3e\x00\x7f\x01\xc8\x01\xc6\x01\x7d\x01\x3b\x00\x3b\x00\x3b\x00\x7a\x00\x00\x00\x00\x00\xc5\x01\xc4\x01\x04\x00\xf7\xff\x7d\x01\x3b\x00\x3b\x00\x90\x00\x00\x00\x6b\x00\xc1\x01\xc1\x01\x00\x00\x00\x00\xb3\x01\xc7\x01\x7f\x00\xc0\x01\xbf\x01\x00\x00\xbd\x01\xf2\xff\x00\x00\x3b\x00\xa7\x01\xba\x01\x09\x00\x00\x00\x7e\x00\x34\x00\xbb\x01\x03\x00\x66\x01\x00\x00\xbe\x01\xbc\x01\xb5\x01\xb4\x01\xb2\x01\xb1\x01\x34\x00\x3b\x00\x79\x01\x00\x00\x00\x00\x00\x00\xaf\x01\x7a\x00\xb0\x01\x77\x01\x7a\x00\x00\x00\xae\x01\xab\x01\xa2\x01\xac\x01\x3b\x00\x00\x00\xa9\x01\x77\x01\x77\x01\x75\x01\x3b\x00\x3b\x00\x00\x00\x00\x00\x00\x00\x00\x00\xad\x01\xaa\x01\x95\x01\x00\x00\x3b\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa6\x01\x8e\x01\x7a\x00\x7a\x00\xa8\x01\xa5\x01\x00\x00\xa1\x01\xa0\x01\x9c\x01\x9e\x01\x34\x00\x34\x00\x57\x01\x55\x01\x91\x00\xa4\x01\x9a\x01\x00\x00\x80\x01\x3b\x00\x60\x00\x96\x01\x59\x00\x9f\x01\x84\x01\x34\x00\xa3\x01\xff\xff\x00\x00\x00\x00\x7b\x01\x00\x00\x00\x00\x92\x01\x94\x01\x9d\x01\xfe\xff\x00\x00\x31\x01\x8f\x01\x30\x01\x8f\x01\x00\x00\x00\x00\x90\x01\x8d\x01\x8c\x01\x89\x01\x3b\x00\x3b\x00\x7a\x00\x00\x00\x00\x00\x8a\x01\x3b\x00\x6f\x01\x3b\x00\x88\x01\x93\x01\x00\x00\x00\x00\x85\x01\x87\x01\x00\x00\x00\x00\x00\x00\x00\x00\x58\x01\x5e\x01\x5e\x01\x24\x01\x5b\x01\x5b\x01\x69\x00\x86\x01\x3a\x00\x82\x01\x8b\x01\x3b\x00\x7c\x01\x40\x00\x74\x01\x0e\x00\x00\x00\xf8\xff\x00\x00\x00\x00\x6b\x01\x00\x00\x00\x00\x00\x00\x83\x01\x00\x00\xf6\xff\x00\x00\x00\x00\x6a\x01\x00\x00\x00\x00\x00\x00\x7e\x01\x69\x01\x68\x01\x67\x01\x00\x00\x64\x01\x62\x01\x0e\x01\x00\x00\x00\x00\x00\x00\x00\x00\x5b\x01\x5b\x01\x5b\x01\x5b\x01\x5b\x01\x5b\x01\x5a\x01\x7a\x01\x13\x01\x03\x01\x00\x00\xfb\x00\x0a\x00\xe6\x00\x00\x00\xdb\x00\x00\x00\x00\x00\x00\x00\xd4\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe0\x00\xd8\x00\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\x0d\x01\xb0\x00\xb8\x00\xd6\x00\xa3\x00\x9f\x00\xca\x00\x00\x00\x00\x00\x0b\x01\xd2\x00\x00\x00\x00\x00\xa7\x00\x00\x00\x65\x01\x00\x00\x63\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x29\x01\x00\x00\x00\x00\x00\x00\x00\x00\x72\x01\x06\x01\x3c\x01\x00\x00\x71\x01\x70\x01\x6e\x01\x18\x01\x00\x00\x00\x00\x00\x00\x49\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x39\x01\x00\x00\x00\x00\xcd\x00\x04\x01\xff\x00\xfd\x00\x38\x01\x00\x00\x00\x00\x00\x00\x00\x00\xf8\x00\x8e\x00\xcb\x00\xf6\x00\xbd\x00\x47\x01\x00\x00\x5d\x01\xbb\x00\xb3\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xce\x00\x00\x00\xf1\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x43\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x41\x01\xef\x00\x33\x01\x00\x00\x00\x00\x00\x00\x00\x00\x23\x01\x00\x00\x98\x00\x32\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xea\x00\x00\x00\x00\x00\x81\x00\x6c\x00\x2d\x01\xe8\x00\xe3\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe1\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x50\x00\x2c\x01\x1e\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x3f\x01\x99\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa5\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x49\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0f\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\x00\xda\x00\x2c\x01\x00\x00\x00\x00\x00\x00\xd5\x00\xed\xff\xd3\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x28\x01\x27\x01\x00\x00\x25\x01\x22\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x6f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x11\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x01\x1f\x01\x1d\x01\xbc\x00\xad\x00\x5d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xde\xff\x00\x00\xdc\xff\xc7\xff\x00\x00\x00\x00\x00\x00\xf9\xff\x00\x00\xf7\xff\x00\x00\xba\xff\xbd\xff\x00\x00\x00\x00\xb3\xff\xac\xff\xb0\xff\xa1\xff\xa0\xff\x9c\xff\x9e\xff\x00\x00\x00\x00\x00\x00\x99\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xbf\xff\x00\x00\x00\x00\xa5\xff\x97\xff\x98\xff\xa2\xff\xa3\xff\xa4\xff\x00\x00\x00\x00\x96\xff\x94\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb2\xff\xab\xff\xa9\xff\x00\x00\xa1\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf6\xff\xf5\xff\x00\x00\x00\x00\xf8\xff\xc4\xff\xc3\xff\x00\x00\x00\x00\x00\x00\x00\x00\xdb\xff\x00\x00\x00\x00\xdd\xff\x00\x00\x00\x00\x00\x00\x00\x00\xd3\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf4\xff\x00\x00\x8e\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xbc\xff\xbb\xff\xa7\xff\x00\x00\xaf\xff\x90\xff\x00\x00\x00\x00\xaa\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9a\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xbe\xff\x91\xff\xb4\xff\x95\xff\x00\x00\x00\x00\x00\x00\xb6\xff\x00\x00\x9d\xff\x9b\xff\x9f\xff\xa8\xff\x00\x00\x00\x00\xad\xff\x00\x00\x00\x00\x00\x00\xb9\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb8\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc2\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc1\xff\x00\x00\x00\x00\x00\x00\xd2\xff\xd0\xff\x00\x00\xcd\xff\xc5\xff\x00\x00\x00\x00\x00\x00\x00\x00\xda\xff\xeb\xff\x00\x00\xea\xff\x00\x00\xb7\xff\x8d\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xae\xff\x8f\xff\xa6\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb5\xff\xb1\xff\x00\x00\x00\x00\x89\xff\x8a\xff\x8b\xff\x8c\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe0\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc0\xff\x00\x00\xd1\xff\xcf\xff\x00\x00\xcc\xff\xca\xff\xc6\xff\x00\x00\xe3\xff\x00\x00\xd9\xff\xd8\xff\x00\x00\xd6\xff\xe7\xff\xe2\xff\x00\x00\xe9\xff\xf1\xff\xf0\xff\xe6\xff\xe8\xff\xf3\xff\xf2\xff\x88\xff\x87\xff\x92\xff\x93\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdf\xff\x00\x00\x00\x00\x00\x00\xce\xff\x00\x00\xcb\xff\xc9\xff\xd7\xff\x00\x00\xd4\xff\xe1\xff\xe5\xff\xed\xff\xec\xff\xe4\xff\xef\xff\xee\xff\x00\x00\x00\x00\xc8\xff\xd5\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x0f\x00\x01\x00\x16\x00\x01\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x13\x00\x15\x00\x08\x00\x15\x00\x01\x00\x02\x00\x08\x00\x07\x00\x0e\x00\x15\x00\x15\x00\x07\x00\x05\x00\x08\x00\x14\x00\x08\x00\x28\x00\x11\x00\x0f\x00\x19\x00\x15\x00\x11\x00\x2a\x00\x2a\x00\x2a\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x2a\x00\x2a\x00\x29\x00\x2a\x00\x29\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x05\x00\x2a\x00\x08\x00\x08\x00\x02\x00\x03\x00\x04\x00\x05\x00\x0e\x00\x0f\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x07\x00\x0e\x00\x08\x00\x06\x00\x19\x00\x12\x00\x07\x00\x0a\x00\x0e\x00\x10\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x12\x00\x11\x00\x01\x00\x02\x00\x19\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x0e\x00\x07\x00\x04\x00\x0e\x00\x1a\x00\x1b\x00\x08\x00\x12\x00\x07\x00\x14\x00\x19\x00\x11\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x07\x00\x11\x00\x08\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x0e\x00\x10\x00\x0b\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x11\x00\x12\x00\x16\x00\x19\x00\x15\x00\x07\x00\x07\x00\x1c\x00\x0e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x14\x00\x11\x00\x11\x00\x26\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x16\x00\x07\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x0e\x00\x00\x00\x05\x00\x10\x00\x12\x00\x08\x00\x01\x00\x06\x00\x07\x00\x19\x00\x09\x00\x0a\x00\x07\x00\x0c\x00\x09\x00\x0a\x00\x16\x00\x0c\x00\x0b\x00\x04\x00\x0b\x00\x1a\x00\x1b\x00\x08\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x08\x00\x15\x00\x0d\x00\x0e\x00\x0f\x00\x04\x00\x11\x00\x12\x00\x08\x00\x08\x00\x15\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x0e\x00\x0f\x00\x15\x00\x11\x00\x12\x00\x06\x00\x07\x00\x15\x00\x09\x00\x0a\x00\x07\x00\x0c\x00\x09\x00\x0a\x00\x07\x00\x0c\x00\x09\x00\x0a\x00\x07\x00\x0c\x00\x09\x00\x0a\x00\x16\x00\x0c\x00\x16\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x11\x00\x15\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x10\x00\x15\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x11\x00\x15\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x2a\x00\x15\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x2a\x00\x15\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x11\x00\x15\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x10\x00\x15\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x07\x00\x15\x00\x11\x00\x12\x00\x11\x00\x12\x00\x15\x00\x04\x00\x15\x00\x04\x00\x04\x00\x08\x00\x04\x00\x08\x00\x08\x00\x04\x00\x08\x00\x04\x00\x04\x00\x08\x00\x16\x00\x08\x00\x08\x00\x13\x00\x14\x00\x15\x00\x16\x00\x27\x00\x13\x00\x14\x00\x15\x00\x16\x00\x16\x00\x17\x00\x13\x00\x14\x00\x15\x00\x16\x00\x14\x00\x15\x00\x16\x00\x16\x00\x17\x00\x18\x00\x14\x00\x15\x00\x16\x00\x16\x00\x17\x00\x18\x00\x14\x00\x15\x00\x16\x00\x16\x00\x17\x00\x18\x00\x16\x00\x17\x00\x18\x00\x25\x00\x25\x00\x27\x00\x27\x00\x1a\x00\x1b\x00\x1a\x00\x1b\x00\x1a\x00\x1b\x00\x02\x00\x03\x00\x1a\x00\x1b\x00\x1a\x00\x1b\x00\x02\x00\x03\x00\x02\x00\x03\x00\x0e\x00\x0f\x00\x11\x00\x0e\x00\x0f\x00\x16\x00\x17\x00\x01\x00\x02\x00\x1d\x00\x1e\x00\x1d\x00\x1e\x00\x01\x00\x02\x00\x01\x00\x02\x00\x01\x00\x02\x00\x16\x00\x17\x00\x01\x00\x02\x00\x01\x00\x02\x00\x01\x00\x02\x00\x16\x00\x11\x00\x16\x00\x16\x00\x16\x00\x27\x00\x10\x00\x27\x00\x0e\x00\x11\x00\x27\x00\x27\x00\x27\x00\x0e\x00\x07\x00\x11\x00\x2a\x00\x2a\x00\x10\x00\x10\x00\x13\x00\x06\x00\x10\x00\x13\x00\x13\x00\x0e\x00\x01\x00\x13\x00\x13\x00\x11\x00\x0e\x00\x11\x00\x01\x00\x2a\x00\x07\x00\x11\x00\x24\x00\x0f\x00\x2a\x00\x07\x00\x07\x00\x0f\x00\x12\x00\x07\x00\x1b\x00\x07\x00\x12\x00\x12\x00\x07\x00\x13\x00\x10\x00\x07\x00\x2a\x00\x0d\x00\x11\x00\x01\x00\x0b\x00\x0b\x00\x13\x00\x0b\x00\x0b\x00\x13\x00\x13\x00\x07\x00\x06\x00\x0a\x00\x07\x00\x07\x00\x01\x00\x0c\x00\xff\xff\x09\x00\xff\xff\x0a\x00\xff\xff\x0e\x00\x29\x00\x0d\x00\x0d\x00\x0d\x00\x1b\x00\x07\x00\xff\xff\x24\x00\x10\x00\xff\xff\xff\xff\x24\x00\x12\x00\x12\x00\x12\x00\xff\xff\xff\xff\x2b\x00\xff\xff\x2b\x00\xff\xff\x18\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x1a\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x24\x00\x2b\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x2b\x00\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\x0d\x00\x4f\x00\xc6\x00\x9b\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x6e\x00\x05\x01\x1f\x00\x09\x01\x2c\x00\x34\x00\xcf\x00\x0c\x01\x20\x00\xd6\x00\xdd\x00\xe1\x00\x02\x01\xd2\x00\x70\x00\xd9\x00\x0e\x00\x0d\x01\x35\x00\x21\x00\xa1\x00\xe2\x00\x06\x01\x6f\x00\x0a\x01\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\xd7\x00\xde\x00\x50\x00\x51\x00\x9c\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x06\x01\xa2\x00\x1f\x00\xd9\x00\x63\x00\x64\x00\x65\x00\x66\x00\x20\x00\x4e\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\xea\x00\x68\x00\x1f\x00\x7a\x00\x21\x00\x69\x00\xe4\x00\x98\xff\x20\x00\xeb\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x7b\x00\xe5\x00\x2c\x00\x2d\x00\x21\x00\x2c\x00\x40\x00\x1c\x00\x1d\x00\x1e\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x38\x00\xa8\x00\x12\x01\x41\x00\xdf\x00\x61\x00\xef\x00\x42\x00\xab\x00\x43\x00\xbf\x00\xa9\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\xed\x00\xac\x00\x1f\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x20\x00\xee\x00\xe6\x00\x2c\x00\x40\x00\x1c\x00\x1d\x00\x1e\x00\x4c\x00\x17\x00\x82\x00\x21\x00\x18\x00\x9f\x00\x59\x00\x49\x00\x41\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x43\x00\xa0\x00\x5a\x00\x4a\x00\x63\x00\x64\x00\x65\x00\x66\x00\x67\x00\x83\x00\xb1\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x68\x00\x0e\x00\xd8\x00\xb2\x00\x69\x00\xd9\x00\x10\x00\x0f\x00\x08\x00\x6c\x00\x09\x00\x0a\x00\x11\x00\x0b\x00\x09\x00\x0a\x00\x8b\x00\x0b\x00\xac\x00\x13\x01\x4b\x00\xb6\x00\x61\x00\xef\x00\x4c\x00\x17\x00\x4c\x00\x17\x00\x18\x00\x5c\x00\x18\x00\x26\x00\x27\x00\x14\x00\x14\x01\x16\x00\x17\x00\x5e\x00\xef\x00\x18\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x69\x00\x14\x00\x18\x00\x16\x00\x17\x00\x07\x00\x08\x00\x18\x00\x09\x00\x0a\x00\x54\x00\x0b\x00\x09\x00\x0a\x00\x51\x00\x0b\x00\x09\x00\x0a\x00\x12\x00\x0b\x00\x09\x00\x0a\x00\x6b\x00\x0b\x00\x75\x00\xc5\x00\x17\x00\xc7\x00\x17\x00\x18\x00\x1b\x01\x18\x00\xc9\x00\x17\x00\xca\x00\x17\x00\x18\x00\x1c\x01\x18\x00\xc1\x00\x17\x00\x7f\x00\x17\x00\x18\x00\x0b\x01\x18\x00\x80\x00\x17\x00\x85\x00\x17\x00\x18\x00\x19\x01\x18\x00\x90\x00\x17\x00\xa4\x00\x17\x00\x18\x00\x1a\x01\x18\x00\x6a\x00\x17\x00\x35\x00\x17\x00\x18\x00\x0e\x01\x18\x00\x72\x00\x17\x00\x73\x00\x17\x00\x18\x00\x0f\x01\x18\x00\x74\x00\x17\x00\x35\x00\x17\x00\x18\x00\x10\x01\x18\x00\x52\x00\x17\x00\x28\x00\x17\x00\x18\x00\x15\x01\x18\x00\x16\x01\x17\x01\xef\x00\xee\x00\xef\x00\xef\x00\xf1\x00\xef\x00\xf4\x00\xf5\x00\xef\x00\x2a\x00\xef\x00\xef\x00\xbe\x00\x3c\x00\x3d\x00\x3e\x00\xfd\x00\x8d\x00\x3c\x00\x3d\x00\x3e\x00\xf3\x00\xf4\x00\x3b\x00\x3c\x00\x3d\x00\x3e\x00\x71\x00\x3d\x00\x3e\x00\x30\x00\x81\x00\x32\x00\x8a\x00\x3d\x00\x3e\x00\x30\x00\x8f\x00\x32\x00\x71\x00\x3d\x00\x3e\x00\x30\x00\x78\x00\x32\x00\x30\x00\x31\x00\x32\x00\xd1\x00\xd4\x00\xd2\x00\xd5\x00\xb7\x00\x61\x00\x91\x00\x61\x00\x9d\x00\x61\x00\x5f\x00\x47\x00\x60\x00\x61\x00\x7e\x00\x61\x00\x46\x00\x47\x00\x4a\x00\x47\x00\x5e\x00\xf1\x00\x12\x01\x5e\x00\xf1\x00\xf7\x00\xf8\x00\x2c\x00\x2d\x00\xb3\x00\xb4\x00\xb5\x00\xb6\x00\x2c\x00\x34\x00\x2c\x00\x2d\x00\x2c\x00\x34\x00\x99\x00\x9a\x00\x2c\x00\x2d\x00\x2c\x00\x34\x00\x2c\x00\x2d\x00\x2d\x00\xe3\x00\x2e\x00\x2f\x00\x36\x00\xfe\x00\x11\x01\xff\x00\x5e\x00\xe6\x00\x00\x01\x01\x01\x02\x01\x5e\x00\xe8\x00\xe9\x00\x04\x01\x08\x01\xec\x00\xf9\x00\xfa\x00\xfb\x00\xc9\x00\xfc\x00\xcc\x00\x5e\x00\xd8\x00\xcd\x00\xce\x00\xcf\x00\x5e\x00\xdb\x00\xdf\x00\xdc\x00\xa7\x00\xaa\x00\xa6\x00\xaf\x00\xae\x00\xb0\x00\xbd\x00\xb9\x00\xba\x00\xbe\x00\xc3\x00\xc4\x00\xbb\x00\xbc\x00\xc5\x00\x88\x00\xc1\x00\x8d\x00\x6f\x00\x87\x00\x85\x00\xa3\x00\x93\x00\x94\x00\x89\x00\x95\x00\x96\x00\x8a\x00\x8f\x00\x97\x00\x98\x00\x9d\x00\x57\x00\x58\x00\x5b\x00\x56\x00\x00\x00\x7c\x00\x00\x00\x7e\x00\x00\x00\x5e\x00\xa4\x00\x98\xff\x71\x00\x77\x00\x7d\x00\x45\x00\x00\x00\x5c\x00\x78\x00\x00\x00\x00\x00\x2a\x00\x39\x00\x3a\x00\x3b\x00\x00\x00\x00\x00\xff\xff\x00\x00\xff\xff\x00\x00\x44\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x54\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x46\x00\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xff\xff\x00\x00"#

happyReduceArr = Happy_Data_Array.array (6, 120) [
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38),
	(39 , happyReduce_39),
	(40 , happyReduce_40),
	(41 , happyReduce_41),
	(42 , happyReduce_42),
	(43 , happyReduce_43),
	(44 , happyReduce_44),
	(45 , happyReduce_45),
	(46 , happyReduce_46),
	(47 , happyReduce_47),
	(48 , happyReduce_48),
	(49 , happyReduce_49),
	(50 , happyReduce_50),
	(51 , happyReduce_51),
	(52 , happyReduce_52),
	(53 , happyReduce_53),
	(54 , happyReduce_54),
	(55 , happyReduce_55),
	(56 , happyReduce_56),
	(57 , happyReduce_57),
	(58 , happyReduce_58),
	(59 , happyReduce_59),
	(60 , happyReduce_60),
	(61 , happyReduce_61),
	(62 , happyReduce_62),
	(63 , happyReduce_63),
	(64 , happyReduce_64),
	(65 , happyReduce_65),
	(66 , happyReduce_66),
	(67 , happyReduce_67),
	(68 , happyReduce_68),
	(69 , happyReduce_69),
	(70 , happyReduce_70),
	(71 , happyReduce_71),
	(72 , happyReduce_72),
	(73 , happyReduce_73),
	(74 , happyReduce_74),
	(75 , happyReduce_75),
	(76 , happyReduce_76),
	(77 , happyReduce_77),
	(78 , happyReduce_78),
	(79 , happyReduce_79),
	(80 , happyReduce_80),
	(81 , happyReduce_81),
	(82 , happyReduce_82),
	(83 , happyReduce_83),
	(84 , happyReduce_84),
	(85 , happyReduce_85),
	(86 , happyReduce_86),
	(87 , happyReduce_87),
	(88 , happyReduce_88),
	(89 , happyReduce_89),
	(90 , happyReduce_90),
	(91 , happyReduce_91),
	(92 , happyReduce_92),
	(93 , happyReduce_93),
	(94 , happyReduce_94),
	(95 , happyReduce_95),
	(96 , happyReduce_96),
	(97 , happyReduce_97),
	(98 , happyReduce_98),
	(99 , happyReduce_99),
	(100 , happyReduce_100),
	(101 , happyReduce_101),
	(102 , happyReduce_102),
	(103 , happyReduce_103),
	(104 , happyReduce_104),
	(105 , happyReduce_105),
	(106 , happyReduce_106),
	(107 , happyReduce_107),
	(108 , happyReduce_108),
	(109 , happyReduce_109),
	(110 , happyReduce_110),
	(111 , happyReduce_111),
	(112 , happyReduce_112),
	(113 , happyReduce_113),
	(114 , happyReduce_114),
	(115 , happyReduce_115),
	(116 , happyReduce_116),
	(117 , happyReduce_117),
	(118 , happyReduce_118),
	(119 , happyReduce_119),
	(120 , happyReduce_120)
	]

happy_n_terms = 44 :: Int
happy_n_nonterms = 28 :: Int

happyReduce_6 = happySpecReduce_1  0# happyReduction_6
happyReduction_6 happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	happyIn9
		 (let (rs,finfo) = happy_var_1 in ((rs,[],[]),finfo)
	)}

happyReduce_7 = happySpecReduce_2  0# happyReduction_7
happyReduction_7 happy_x_2
	happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_2 of { happy_var_2 -> 
	happyIn9
		 (let 
                                                              (rs,finfo) = happy_var_1 
                                                              cs = [c | c <- happy_var_2, not $ isUNION c]
                                                              ds = [c | c <- happy_var_2, isUNION c]
                                                          in ((rs,cs,ds),finfo)
	)}}

happyReduce_8 = happySpecReduce_1  1# happyReduction_8
happyReduction_8 happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	happyIn10
		 (let (rs,finfo) = happy_var_1 in ((rs,[]),finfo)
	)}

happyReduce_9 = happySpecReduce_2  1# happyReduction_9
happyReduction_9 happy_x_2
	happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_2 of { happy_var_2 -> 
	happyIn10
		 (let 
                                                              (rs,finfo) = happy_var_1 
                                                              cs = happy_var_2
                                                          in ((rs,cs),finfo)
	)}}

happyReduce_10 = happySpecReduce_1  2# happyReduction_10
happyReduction_10 happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	happyIn11
		 ([happy_var_1]
	)}

happyReduce_11 = happySpecReduce_2  2# happyReduction_11
happyReduction_11 happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_1 of { happy_var_1 -> 
	case happyOut11 happy_x_2 of { happy_var_2 -> 
	happyIn11
		 (happy_var_1:happy_var_2
	)}}

happyReduce_12 = happyReduce 6# 3# happyReduction_12
happyReduction_12 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut17 happy_x_5 of { happy_var_5 -> 
	happyIn12
		 (Single (Left happy_var_2) (Left happy_var_5) []
	) `HappyStk` happyRest}}

happyReduce_13 = happyReduce 6# 3# happyReduction_13
happyReduction_13 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut17 happy_x_5 of { happy_var_5 -> 
	happyIn12
		 (Single (Left happy_var_2) (Right happy_var_5)[]
	) `HappyStk` happyRest}}

happyReduce_14 = happyReduce 6# 3# happyReduction_14
happyReduction_14 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut17 happy_x_5 of { happy_var_5 -> 
	happyIn12
		 (Single (Right happy_var_2) (Left happy_var_5)[]
	) `HappyStk` happyRest}}

happyReduce_15 = happyReduce 6# 3# happyReduction_15
happyReduction_15 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut17 happy_x_5 of { happy_var_5 -> 
	happyIn12
		 (Single (Right happy_var_2) (Right happy_var_5)[]
	) `HappyStk` happyRest}}

happyReduce_16 = happyReduce 8# 3# happyReduction_16
happyReduction_16 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut17 happy_x_5 of { happy_var_5 -> 
	case happyOut13 happy_x_8 of { happy_var_8 -> 
	happyIn12
		 (Single (Left happy_var_2) (Left happy_var_5) happy_var_8
	) `HappyStk` happyRest}}}

happyReduce_17 = happyReduce 8# 3# happyReduction_17
happyReduction_17 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut17 happy_x_5 of { happy_var_5 -> 
	case happyOut13 happy_x_8 of { happy_var_8 -> 
	happyIn12
		 (Single (Left happy_var_2) (Right happy_var_5) happy_var_8
	) `HappyStk` happyRest}}}

happyReduce_18 = happyReduce 8# 3# happyReduction_18
happyReduction_18 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut17 happy_x_5 of { happy_var_5 -> 
	case happyOut13 happy_x_8 of { happy_var_8 -> 
	happyIn12
		 (Single (Right happy_var_2) (Left happy_var_5) happy_var_8
	) `HappyStk` happyRest}}}

happyReduce_19 = happyReduce 8# 3# happyReduction_19
happyReduction_19 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut17 happy_x_5 of { happy_var_5 -> 
	case happyOut13 happy_x_8 of { happy_var_8 -> 
	happyIn12
		 (Single (Right happy_var_2) (Right happy_var_5) happy_var_8
	) `HappyStk` happyRest}}}

happyReduce_20 = happyReduce 4# 3# happyReduction_20
happyReduction_20 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	happyIn12
		 (All (Right happy_var_2) [] []
	) `HappyStk` happyRest}

happyReduce_21 = happyReduce 4# 3# happyReduction_21
happyReduction_21 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	happyIn12
		 (All (Left happy_var_2) [] []
	) `HappyStk` happyRest}

happyReduce_22 = happyReduce 6# 3# happyReduction_22
happyReduction_22 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut13 happy_x_6 of { happy_var_6 -> 
	happyIn12
		 (All (Right happy_var_2) happy_var_6 []
	) `HappyStk` happyRest}}

happyReduce_23 = happyReduce 6# 3# happyReduction_23
happyReduction_23 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut13 happy_x_6 of { happy_var_6 -> 
	happyIn12
		 (All (Left happy_var_2) happy_var_6 []
	) `HappyStk` happyRest}}

happyReduce_24 = happyReduce 6# 3# happyReduction_24
happyReduction_24 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut13 happy_x_6 of { happy_var_6 -> 
	happyIn12
		 (All (Right happy_var_2) [] happy_var_6
	) `HappyStk` happyRest}}

happyReduce_25 = happyReduce 6# 3# happyReduction_25
happyReduction_25 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut13 happy_x_6 of { happy_var_6 -> 
	happyIn12
		 (All (Left happy_var_2) [] happy_var_6
	) `HappyStk` happyRest}}

happyReduce_26 = happyReduce 8# 3# happyReduction_26
happyReduction_26 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut13 happy_x_6 of { happy_var_6 -> 
	case happyOut13 happy_x_8 of { happy_var_8 -> 
	happyIn12
		 (All (Right happy_var_2) happy_var_6 happy_var_8
	) `HappyStk` happyRest}}}

happyReduce_27 = happyReduce 8# 3# happyReduction_27
happyReduction_27 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut13 happy_x_6 of { happy_var_6 -> 
	case happyOut13 happy_x_8 of { happy_var_8 -> 
	happyIn12
		 (All (Left happy_var_2) happy_var_6 happy_var_8
	) `HappyStk` happyRest}}}

happyReduce_28 = happyReduce 6# 3# happyReduction_28
happyReduction_28 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut17 happy_x_2 of { happy_var_2 -> 
	case happyOut14 happy_x_5 of { happy_var_5 -> 
	happyIn12
		 (UNION happy_var_2 happy_var_5
	) `HappyStk` happyRest}}

happyReduce_29 = happySpecReduce_1  4# happyReduction_29
happyReduction_29 happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	happyIn13
		 ([happy_var_1]
	)}

happyReduce_30 = happySpecReduce_3  4# happyReduction_30
happyReduction_30 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut14 happy_x_2 of { happy_var_2 -> 
	happyIn13
		 (happy_var_2
	)}

happyReduce_31 = happySpecReduce_1  5# happyReduction_31
happyReduction_31 happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 ([happy_var_1]
	)}

happyReduce_32 = happySpecReduce_3  5# happyReduction_32
happyReduction_32 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	case happyOut14 happy_x_3 of { happy_var_3 -> 
	happyIn14
		 (happy_var_1:happy_var_3
	)}}

happyReduce_33 = happySpecReduce_1  6# happyReduction_33
happyReduction_33 happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	happyIn15
		 (let (rs,finfo) = happy_var_1 
                                          in (([r | r <- rs, standardReduction r, not (answerRule r)]
                                              ,[r | r <- rs, not (standardReduction r), not (answerRule r)]
                                              ,[r{ruleName=let (a,b,c,d)=(ruleName r) in if b == "ANSWER" then (a,b,n,d) else (a,b,c,d)} | (n,r) <- zip [1..] [r | r <- rs, answerRule r]]
                                              ),finfo)
	)}

happyReduce_34 = happySpecReduce_3  6# happyReduction_34
happyReduction_34 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	case happyOut16 happy_x_3 of { happy_var_3 -> 
	happyIn15
		 (let 
                                          (rs1,finfo1) = happy_var_1
                                          (rs2,finfo2) = happy_var_3
                                          rs1' = [r{standardReduction=True} | r <- rs1, not(answerRule r)]
                                          rs2' = [r{standardReduction=False} | r <- rs2, not(answerRule r)]
                                          rs3' = [r{standardReduction=False} | r <- (rs1 ++ rs2),(answerRule r)]
                                          rs3'' = [r{ruleName=let (a,b,c,d)=(ruleName r) in if b == "ANSWER" then (a,b,n,d) else (a,b,c,d)} | (n,r) <- zip [1..] [r | r <- rs3']]
                                         in ((rs1',rs2',rs3''),finfo1 ++ finfo2)
	)}}

happyReduce_35 = happySpecReduce_1  7# happyReduction_35
happyReduction_35 happy_x_1
	 =  case happyOut19 happy_x_1 of { happy_var_1 -> 
	happyIn16
		 (let (r,finfo) = happy_var_1 in ([r],finfo)
	)}

happyReduce_36 = happySpecReduce_2  7# happyReduction_36
happyReduction_36 happy_x_2
	happy_x_1
	 =  case happyOut19 happy_x_1 of { happy_var_1 -> 
	case happyOut16 happy_x_2 of { happy_var_2 -> 
	happyIn16
		 (let 
                                          (r,finfo1) = happy_var_1
                                          (rs,finfo2) = happy_var_2
                                       in (r:rs,finfo1 ++ finfo2)
	)}}

happyReduce_37 = happySpecReduce_3  8# happyReduction_37
happyReduction_37 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TokenVar  happy_var_2 _) -> 
	happyIn17
		 ((False,happy_var_2,1,False)
	)}

happyReduce_38 = happyReduce 5# 8# happyReduction_38
happyReduction_38 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_4 of { (TokenVar  happy_var_4 _) -> 
	happyIn17
		 ((True,happy_var_4,1,False)
	) `HappyStk` happyRest}

happyReduce_39 = happyReduce 5# 8# happyReduction_39
happyReduction_39 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenVar  happy_var_2 _) -> 
	case happyOutTok happy_x_4 of { (TokenNumber happy_var_4 _) -> 
	happyIn17
		 ((False,happy_var_2,happy_var_4,False)
	) `HappyStk` happyRest}}

happyReduce_40 = happyReduce 7# 8# happyReduction_40
happyReduction_40 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_4 of { (TokenVar  happy_var_4 _) -> 
	case happyOutTok happy_x_6 of { (TokenNumber happy_var_6 _) -> 
	happyIn17
		 ((True,happy_var_4,happy_var_6,False)
	) `HappyStk` happyRest}}

happyReduce_41 = happyReduce 5# 8# happyReduction_41
happyReduction_41 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenVar  happy_var_2 _) -> 
	happyIn17
		 ((False,happy_var_2,1,True)
	) `HappyStk` happyRest}

happyReduce_42 = happyReduce 9# 8# happyReduction_42
happyReduction_42 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_4 of { (TokenVar  happy_var_4 _) -> 
	case happyOutTok happy_x_8 of { (TokenNumber happy_var_8 _) -> 
	happyIn17
		 ((True,happy_var_4,happy_var_8,True)
	) `HappyStk` happyRest}}

happyReduce_43 = happyReduce 7# 8# happyReduction_43
happyReduction_43 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenVar  happy_var_2 _) -> 
	case happyOutTok happy_x_6 of { (TokenNumber happy_var_6 _) -> 
	happyIn17
		 ((False,happy_var_2,happy_var_6,True)
	) `HappyStk` happyRest}}

happyReduce_44 = happySpecReduce_3  9# happyReduction_44
happyReduction_44 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TokenVar  happy_var_2 _) -> 
	happyIn18
		 ((0,False,happy_var_2,1,False)
	)}

happyReduce_45 = happyReduce 5# 9# happyReduction_45
happyReduction_45 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_4 of { (TokenVar  happy_var_4 _) -> 
	happyIn18
		 ((0,True,happy_var_4,1,False)
	) `HappyStk` happyRest}

happyReduce_46 = happyReduce 7# 9# happyReduction_46
happyReduction_46 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenNumber happy_var_2 _) -> 
	case happyOutTok happy_x_6 of { (TokenVar  happy_var_6 _) -> 
	happyIn18
		 ((happy_var_2,True,happy_var_6,1,False)
	) `HappyStk` happyRest}}

happyReduce_47 = happyReduce 5# 9# happyReduction_47
happyReduction_47 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenVar  happy_var_2 _) -> 
	case happyOutTok happy_x_4 of { (TokenNumber happy_var_4 _) -> 
	happyIn18
		 ((0,False,happy_var_2,happy_var_4,False)
	) `HappyStk` happyRest}}

happyReduce_48 = happyReduce 7# 9# happyReduction_48
happyReduction_48 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_4 of { (TokenVar  happy_var_4 _) -> 
	case happyOutTok happy_x_6 of { (TokenNumber happy_var_6 _) -> 
	happyIn18
		 ((0,True,happy_var_4,happy_var_6,False)
	) `HappyStk` happyRest}}

happyReduce_49 = happyReduce 9# 9# happyReduction_49
happyReduction_49 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenNumber happy_var_2 _) -> 
	case happyOutTok happy_x_6 of { (TokenVar  happy_var_6 _) -> 
	case happyOutTok happy_x_8 of { (TokenNumber happy_var_8 _) -> 
	happyIn18
		 ((happy_var_2,True,happy_var_6,happy_var_8,False)
	) `HappyStk` happyRest}}}

happyReduce_50 = happyReduce 5# 9# happyReduction_50
happyReduction_50 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenVar  happy_var_2 _) -> 
	happyIn18
		 ((0,False,happy_var_2,1,True)
	) `HappyStk` happyRest}

happyReduce_51 = happyReduce 7# 9# happyReduction_51
happyReduction_51 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_4 of { (TokenVar  happy_var_4 _) -> 
	happyIn18
		 ((0,True,happy_var_4,1,True)
	) `HappyStk` happyRest}

happyReduce_52 = happyReduce 9# 9# happyReduction_52
happyReduction_52 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenNumber happy_var_2 _) -> 
	case happyOutTok happy_x_6 of { (TokenVar  happy_var_6 _) -> 
	happyIn18
		 ((happy_var_2,True,happy_var_6,1,True)
	) `HappyStk` happyRest}}

happyReduce_53 = happyReduce 7# 9# happyReduction_53
happyReduction_53 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenVar  happy_var_2 _) -> 
	case happyOutTok happy_x_6 of { (TokenNumber happy_var_6 _) -> 
	happyIn18
		 ((0,False,happy_var_2,happy_var_6,True)
	) `HappyStk` happyRest}}

happyReduce_54 = happyReduce 9# 9# happyReduction_54
happyReduction_54 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_4 of { (TokenVar  happy_var_4 _) -> 
	case happyOutTok happy_x_8 of { (TokenNumber happy_var_8 _) -> 
	happyIn18
		 ((0,True,happy_var_4,happy_var_8,True)
	) `HappyStk` happyRest}}

happyReduce_55 = happyReduce 11# 9# happyReduction_55
happyReduction_55 (happy_x_11 `HappyStk`
	happy_x_10 `HappyStk`
	happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (TokenNumber happy_var_2 _) -> 
	case happyOutTok happy_x_6 of { (TokenVar  happy_var_6 _) -> 
	case happyOutTok happy_x_10 of { (TokenNumber happy_var_10 _) -> 
	happyIn18
		 ((happy_var_2,True,happy_var_6,happy_var_10,True)
	) `HappyStk` happyRest}}}

happyReduce_56 = happySpecReduce_1  10# happyReduction_56
happyReduction_56 happy_x_1
	 =  case happyOut21 happy_x_1 of { happy_var_1 -> 
	happyIn19
		 (happy_var_1
	)}

happyReduce_57 = happyReduce 7# 10# happyReduction_57
happyReduction_57 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_3 of { (TokenVar  happy_var_3 _) -> 
	case happyOutTok happy_x_5 of { (TokenNumber happy_var_5 _) -> 
	case happyOut20 happy_x_7 of { happy_var_7 -> 
	happyIn19
		 (let (r,f) = happy_var_7 in (r{ruleName=(False,happy_var_3,happy_var_5,False)},f)
	) `HappyStk` happyRest}}}

happyReduce_58 = happyReduce 5# 10# happyReduction_58
happyReduction_58 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_3 of { (TokenVar  happy_var_3 _) -> 
	case happyOut20 happy_x_5 of { happy_var_5 -> 
	happyIn19
		 (let (r,f) = happy_var_5 in (r{ruleName=(False,happy_var_3,0,False)},f)
	) `HappyStk` happyRest}}

happyReduce_59 = happySpecReduce_2  10# happyReduction_59
happyReduction_59 happy_x_2
	happy_x_1
	 =  case happyOut20 happy_x_2 of { happy_var_2 -> 
	happyIn19
		 (happy_var_2
	)}

happyReduce_60 = happySpecReduce_1  11# happyReduction_60
happyReduction_60 happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	happyIn20
		 (let (e,finfo) = happy_var_1 
                                                        in if isExpr e then
                                                            (ConstrainedRule {
                                                               ruleName = (False,"ANSWER",0,False)
                                                              ,rule = e :==>: (Fn "ANSWER" [])
                                                              ,nonEmptyCtxts = []
                                                              ,nonEmptyEnvs  = []
                                                              ,nonCapCon     = []
                                                              ,priority = 0
                                                              ,standardReduction = False
                                                              ,answerRule = True
                                                              }
                                                             ,finfo 
                                                             )
                                                            else error ("expression " ++ show e ++ " is not an expression, but a context")
	)}

happyReduce_61 = happySpecReduce_3  11# happyReduction_61
happyReduction_61 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	case happyOut35 happy_x_3 of { happy_var_3 -> 
	happyIn20
		 (let (e,finfo) = happy_var_1 
                                                        in if isExpr e then
                                                            (ConstrainedRule {
                                                               ruleName = (False,"ANSWER",0,False)
                                                              ,rule = e :==>: (Fn "ANSWER" [])
                                                              ,nonEmptyCtxts = ctxtcon happy_var_3
                                                              ,nonEmptyEnvs  = envcon happy_var_3
                                                              ,nonCapCon     = capcon happy_var_3  
                                                              ,priority = 0
                                                              ,standardReduction = False
                                                              ,answerRule = True
                                                              }
                                                             ,finfo 
                                                             )
                                                            else error ("expression " ++ show e ++ " is not an expression, but a context")
	)}}

happyReduce_62 = happyReduce 4# 12# happyReduction_62
happyReduction_62 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut18 happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOut26 happy_x_4 of { happy_var_4 -> 
	happyIn21
		 (let 
                                          (e1,finfo1) = happy_var_2
                                          (e2,finfo2) = happy_var_4
                                       in
                                        if isExpr e1 then 
                                                      if isExpr e2 then 
                                                                      (ConstrainedRule {
                                                                               ruleName = let (prio,sr,name,number,trans) = happy_var_1 in (sr,name,number,trans) 
                                                                              ,rule = e1 :==>: e2
                                                                              ,nonEmptyCtxts = []
                                                                              ,nonEmptyEnvs  = []
                                                                              ,nonCapCon     = []
                                                                              ,priority = let (prio,sr,name,number,trans) = happy_var_1 in prio
                                                                              ,standardReduction = let (prio,sr,name,number,trans) = happy_var_1 in sr
                                                                              ,answerRule = False
                                                                              }
                                                                      ,finfo1++finfo2
                                                                      )
                                                                   else error ("expression " ++ show e2 ++ " is not an expression, but a context")
                                                      else error ("expression " ++ show e1 ++ " is not an expression, but a context")
	) `HappyStk` happyRest}}}

happyReduce_63 = happyReduce 6# 12# happyReduction_63
happyReduction_63 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut18 happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOut26 happy_x_4 of { happy_var_4 -> 
	case happyOut35 happy_x_6 of { happy_var_6 -> 
	happyIn21
		 (let 
                                                              (e1,finfo1) = happy_var_2
                                                              (e2,finfo2) = happy_var_4
                                                           in if isExpr e1 then 
                                                               if isExpr e2 then 
                                                                      (ConstrainedRule {
                                                                               ruleName = let (prio,sr,name,number,trans) = happy_var_1 in (sr,name,number,trans)
                                                                              ,rule = e1 :==>: e2
                                                                              ,nonEmptyCtxts = ctxtcon happy_var_6
                                                                              ,nonEmptyEnvs  = envcon happy_var_6
                                                                              ,nonCapCon     = capcon happy_var_6
                                                                              ,priority = let (prio,sr,name,number,trans) = happy_var_1 in prio
                                                                              ,standardReduction = let (prio,sr,name,number,trans) = happy_var_1 in sr
                                                                              ,answerRule = False
                                                                              }
                                                                      ,finfo1++finfo2
                                                                      )
                                                                  else error ("expression " ++ show e2 ++ " is not an expression, but a context")
                                                                else error ("expression " ++ show e1 ++ " is not an expression, but a context")
	) `HappyStk` happyRest}}}}

happyReduce_64 = happySpecReduce_1  13# happyReduction_64
happyReduction_64 happy_x_1
	 =  case happyOut23 happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (let (eqs,finfo)=happy_var_1 in ((eqs,[],[],[]),finfo)
	)}

happyReduce_65 = happySpecReduce_3  13# happyReduction_65
happyReduction_65 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut23 happy_x_1 of { happy_var_1 -> 
	case happyOut35 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 (let (eqs,finfo)=happy_var_1 in ((eqs,ctxtcon happy_var_3,envcon happy_var_3, capcon happy_var_3),finfo)
	)}}

happyReduce_66 = happySpecReduce_1  14# happyReduction_66
happyReduction_66 happy_x_1
	 =  case happyOut24 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 (let (e,finfo) = happy_var_1 in ([e],finfo)
	)}

happyReduce_67 = happySpecReduce_3  14# happyReduction_67
happyReduction_67 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut24 happy_x_1 of { happy_var_1 -> 
	case happyOut23 happy_x_3 of { happy_var_3 -> 
	happyIn23
		 (let 
                                      (e,finfo1) = happy_var_1 
                                      (es,finfo2) = happy_var_3
                                    in (e:es,finfo1++finfo2)
	)}}

happyReduce_68 = happySpecReduce_3  15# happyReduction_68
happyReduction_68 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_3 of { happy_var_3 -> 
	happyIn24
		 (let 
                                  (e1,finfo1) = happy_var_1
                                  (e2,finfo2) = happy_var_3
                                in
                                  if isExpr e1 then 
                                   if isExpr e2   then (e1 :=?=: e2,finfo1 ++ finfo2)
                                                  else error ("expression " ++ show e2 ++ " is not an expression, but a context" )
                                   else error ("expression " ++ show e1 ++ " is not an expression, but a context" )
	)}}

happyReduce_69 = happySpecReduce_1  16# happyReduction_69
happyReduction_69 happy_x_1
	 =  case happyOut23 happy_x_1 of { happy_var_1 -> 
	happyIn25
		 (let (eqs,finfo)=happy_var_1 in ((eqs,[],[],[],[],[],[]),finfo)
	)}

happyReduce_70 = happyReduce 4# 16# happyReduction_70
happyReduction_70 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut23 happy_x_1 of { happy_var_1 -> 
	case happyOut35 happy_x_4 of { happy_var_4 -> 
	happyIn25
		 (let (eqs,finfo)=happy_var_1 in ((eqs,[],[],[],ctxtcon happy_var_4,envcon happy_var_4,capcon happy_var_4),finfo)
	) `HappyStk` happyRest}}

happyReduce_71 = happyReduce 4# 16# happyReduction_71
happyReduction_71 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut23 happy_x_1 of { happy_var_1 -> 
	case happyOut35 happy_x_3 of { happy_var_3 -> 
	happyIn25
		 (let (eqs,finfo)=happy_var_1 in ((eqs,ctxtcon happy_var_3,envcon happy_var_3, capcon happy_var_3,[],[],[]),finfo)
	) `HappyStk` happyRest}}

happyReduce_72 = happyReduce 5# 16# happyReduction_72
happyReduction_72 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut23 happy_x_1 of { happy_var_1 -> 
	case happyOut35 happy_x_3 of { happy_var_3 -> 
	case happyOut35 happy_x_5 of { happy_var_5 -> 
	happyIn25
		 (let (eqs,finfo)=happy_var_1 in ((eqs,ctxtcon happy_var_3,envcon happy_var_3, capcon happy_var_3,ctxtcon happy_var_5,envcon happy_var_5,capcon happy_var_5),finfo)
	) `HappyStk` happyRest}}}

happyReduce_73 = happyReduce 4# 17# happyReduction_73
happyReduction_73 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut31 happy_x_2 of { happy_var_2 -> 
	case happyOut26 happy_x_4 of { happy_var_4 -> 
	happyIn26
		 (let 
                                          lamv = happy_var_2
                                          (e,finfo) = happy_var_4 
                                        in (Fn "\\" [Binder [lamv] e],("\\",1,[],[1]):finfo)
	) `HappyStk` happyRest}}

happyReduce_74 = happyReduce 6# 17# happyReduction_74
happyReduction_74 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut32 happy_x_3 of { happy_var_3 -> 
	case happyOut26 happy_x_6 of { happy_var_6 -> 
	happyIn26
		 (let 
                                          (e,finfo) = happy_var_6
                                          (es,finfo') = happy_var_3 
                                        in (Letrec (applyEnvItems es empty) e, finfo ++ finfo')
	) `HappyStk` happyRest}}

happyReduce_75 = happyReduce 4# 17# happyReduction_75
happyReduction_75 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut32 happy_x_2 of { happy_var_2 -> 
	case happyOut26 happy_x_4 of { happy_var_4 -> 
	happyIn26
		 (let 
                                          (e,finfo) = happy_var_4 
                                          (es,finfo') = happy_var_2
                                        in (Letrec (applyEnvItems es empty) e, finfo ++ finfo')
	) `HappyStk` happyRest}}

happyReduce_76 = happySpecReduce_1  17# happyReduction_76
happyReduction_76 happy_x_1
	 =  case happyOut27 happy_x_1 of { happy_var_1 -> 
	happyIn26
		 (happy_var_1
	)}

happyReduce_77 = happySpecReduce_2  18# happyReduction_77
happyReduction_77 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenVar  happy_var_1 _) -> 
	case happyOut28 happy_x_2 of { happy_var_2 -> 
	happyIn27
		 (let 
                                          (argsWithBindArities,finfo) = happy_var_2 
                                          rev = reverse argsWithBindArities
                                          args = map fst rev
                                          bindarities = map snd rev
                                       in   (Fn happy_var_1 args,(happy_var_1, length args,[1],bindarities):finfo) -- default strictness!
	)}}

happyReduce_78 = happyReduce 6# 18# happyReduction_78
happyReduction_78 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut31 happy_x_3 of { happy_var_3 -> 
	case happyOut26 happy_x_5 of { happy_var_5 -> 
	happyIn27
		 (let 
                                          lamv = happy_var_3
                                          (e,finfo) = happy_var_5 
                                        in (Fn "\\" [Binder [lamv] e],("\\",1,[],[1]):finfo)
	) `HappyStk` happyRest}}

happyReduce_79 = happySpecReduce_1  18# happyReduction_79
happyReduction_79 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenVar  happy_var_1 _) -> 
	happyIn27
		 ((Fn happy_var_1 [],[(happy_var_1,0,[],[])])
	)}

happyReduce_80 = happySpecReduce_3  18# happyReduction_80
happyReduction_80 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenVar  happy_var_1 _) -> 
	happyIn27
		 ((Fn happy_var_1 [],[(happy_var_1,0,[],[])])
	)}

happyReduce_81 = happyReduce 5# 18# happyReduction_81
happyReduction_81 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenVar  happy_var_1 _) -> 
	case happyOut34 happy_x_3 of { happy_var_3 -> 
	case happyOut28 happy_x_5 of { happy_var_5 -> 
	happyIn27
		 (let 
                                           (argsWithBindArities,finfo) = happy_var_5 
                                           rev = reverse argsWithBindArities
                                           args = map fst rev
                                           bindarities = map snd rev
                        
                                        in (Fn happy_var_1 args,(happy_var_1,length args,happy_var_3,bindarities):finfo)
	) `HappyStk` happyRest}}}

happyReduce_82 = happyReduce 4# 18# happyReduction_82
happyReduction_82 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenVar  happy_var_1 _) -> 
	case happyOut28 happy_x_4 of { happy_var_4 -> 
	happyIn27
		 (let 
                                           (argsWithBindArities,finfo) = happy_var_4 
                                           rev = reverse argsWithBindArities
                                           args = map fst rev
                                           bindarities = map snd rev
                                        in (Fn happy_var_1 args,(happy_var_1,length args,[],bindarities):finfo)
	) `HappyStk` happyRest}}

happyReduce_83 = happySpecReduce_1  18# happyReduction_83
happyReduction_83 happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	happyIn27
		 (happy_var_1
	)}

happyReduce_84 = happySpecReduce_1  19# happyReduction_84
happyReduction_84 happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	happyIn28
		 (let (a,finfo,barity) = happy_var_1 in ([(a,barity)],finfo)
	)}

happyReduce_85 = happySpecReduce_2  19# happyReduction_85
happyReduction_85 happy_x_2
	happy_x_1
	 =  case happyOut28 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_2 of { happy_var_2 -> 
	happyIn28
		 (let
                                              (as,finfo) = happy_var_1
                                              (a,finfo',barity) = happy_var_2
                                          in ((a,barity):as,finfo++finfo')
	)}}

happyReduce_86 = happySpecReduce_1  20# happyReduction_86
happyReduction_86 happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (let (e,finfo) = happy_var_1 in  (Binder [] e,finfo,0)
	)}

happyReduce_87 = happySpecReduce_3  20# happyReduction_87
happyReduction_87 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 (let (Binder xs e,finfo,i) = happy_var_3 in (Binder (happy_var_1:xs) e,finfo,i+1)
	)}}

happyReduce_88 = happySpecReduce_2  20# happyReduction_88
happyReduction_88 happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_2 of { happy_var_2 -> 
	happyIn29
		 ((VarPos happy_var_2,[],-1)
	)}

happyReduce_89 = happyReduce 4# 20# happyReduction_89
happyReduction_89 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut31 happy_x_3 of { happy_var_3 -> 
	happyIn29
		 ((VarPos happy_var_3,[],-1)
	) `HappyStk` happyRest}

happyReduce_90 = happySpecReduce_2  21# happyReduction_90
happyReduction_90 happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_2 of { happy_var_2 -> 
	happyIn30
		 ((VarL happy_var_2, [])
	)}

happyReduce_91 = happySpecReduce_2  21# happyReduction_91
happyReduction_91 happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_2 of { happy_var_2 -> 
	happyIn30
		 ((VarL happy_var_2, [])
	)}

happyReduce_92 = happySpecReduce_2  21# happyReduction_92
happyReduction_92 happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_2 of { happy_var_2 -> 
	happyIn30
		 ((VarL happy_var_2, [])
	)}

happyReduce_93 = happySpecReduce_2  21# happyReduction_93
happyReduction_93 happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_2 of { happy_var_2 -> 
	happyIn30
		 ((VarL happy_var_2, [])
	)}

happyReduce_94 = happySpecReduce_1  21# happyReduction_94
happyReduction_94 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenMetaVar happy_var_1 _) -> 
	happyIn30
		 ((MetaExpression emptySubstitution happy_var_1,[])
	)}

happyReduce_95 = happySpecReduce_1  21# happyReduction_95
happyReduction_95 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenMetaVarCtxt ACtxt happy_var_1 _) -> 
	happyIn30
		 ((MetaCtxt emptySubstitution ACtxt happy_var_1,[])
	)}

happyReduce_96 = happyReduce 4# 21# happyReduction_96
happyReduction_96 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVarCtxt ACtxt happy_var_1 _) -> 
	case happyOut26 happy_x_3 of { happy_var_3 -> 
	happyIn30
		 (let
                                              (e,finfo) = happy_var_3
                                           in (MetaCtxtSubst emptySubstitution ACtxt happy_var_1 e,finfo)
	) `HappyStk` happyRest}}

happyReduce_97 = happySpecReduce_1  21# happyReduction_97
happyReduction_97 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenMetaVarCtxt TCtxt happy_var_1 _) -> 
	happyIn30
		 ((MetaCtxt emptySubstitution TCtxt happy_var_1,[])
	)}

happyReduce_98 = happyReduce 4# 21# happyReduction_98
happyReduction_98 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVarCtxt TCtxt happy_var_1 _) -> 
	case happyOut26 happy_x_3 of { happy_var_3 -> 
	happyIn30
		 (let 
                                              (e,finfo) = happy_var_3 
                                           in (MetaCtxtSubst emptySubstitution TCtxt happy_var_1 e,finfo)
	) `HappyStk` happyRest}}

happyReduce_99 = happySpecReduce_1  21# happyReduction_99
happyReduction_99 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenMetaVarCtxt Ctxt  happy_var_1 _) -> 
	happyIn30
		 ((MetaCtxt emptySubstitution Ctxt happy_var_1,[])
	)}

happyReduce_100 = happyReduce 4# 21# happyReduction_100
happyReduction_100 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVarCtxt Ctxt  happy_var_1 _) -> 
	case happyOut26 happy_x_3 of { happy_var_3 -> 
	happyIn30
		 (let
                                             (e,finfo) = happy_var_3
                                           in (MetaCtxtSubst emptySubstitution Ctxt happy_var_1 e,finfo)
	) `HappyStk` happyRest}}

happyReduce_101 = happySpecReduce_3  21# happyReduction_101
happyReduction_101 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_2 of { happy_var_2 -> 
	happyIn30
		 (happy_var_2
	)}

happyReduce_102 = happySpecReduce_1  21# happyReduction_102
happyReduction_102 happy_x_1
	 =  happyIn30
		 ((Hole emptySubstitution,[])
	)

happyReduce_103 = happySpecReduce_1  22# happyReduction_103
happyReduction_103 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenMetaVar happy_var_1 _) -> 
	happyIn31
		 (MetaVarLift emptySubstitution happy_var_1
	)}

happyReduce_104 = happySpecReduce_1  22# happyReduction_104
happyReduction_104 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenVar  happy_var_1 _) -> 
	happyIn31
		 (VarLift emptySubstitution  happy_var_1
	)}

happyReduce_105 = happySpecReduce_1  23# happyReduction_105
happyReduction_105 happy_x_1
	 =  case happyOut33 happy_x_1 of { happy_var_1 -> 
	happyIn32
		 (let (e,finfo) = happy_var_1 in  ([e],finfo)
	)}

happyReduce_106 = happySpecReduce_3  23# happyReduction_106
happyReduction_106 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut33 happy_x_1 of { happy_var_1 -> 
	case happyOut32 happy_x_3 of { happy_var_3 -> 
	happyIn32
		 (let 
                                                  (e,finfo) = happy_var_1
                                                  (es,finfo') = happy_var_3
                                                in (e:es,finfo ++ finfo')
	)}}

happyReduce_107 = happySpecReduce_1  24# happyReduction_107
happyReduction_107 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenMetaVar happy_var_1 _) -> 
	happyIn33
		 ((A happy_var_1, [])
	)}

happyReduce_108 = happyReduce 6# 24# happyReduction_108
happyReduction_108 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVar happy_var_1 _) -> 
	case happyOut31 happy_x_3 of { happy_var_3 -> 
	case happyOut26 happy_x_5 of { happy_var_5 -> 
	happyIn33
		 (let (e,finfo) = happy_var_5 in (B (MetaChain emptySubstitution  AChain happy_var_1 happy_var_3 e),finfo)
	) `HappyStk` happyRest}}}

happyReduce_109 = happyReduce 6# 24# happyReduction_109
happyReduction_109 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVar happy_var_1 _) -> 
	case happyOut31 happy_x_3 of { happy_var_3 -> 
	case happyOut31 happy_x_5 of { happy_var_5 -> 
	happyIn33
		 ((B (MetaChain emptySubstitution  VarChain happy_var_1 happy_var_3 (VarL happy_var_5)),[])
	) `HappyStk` happyRest}}}

happyReduce_110 = happySpecReduce_3  24# happyReduction_110
happyReduction_110 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_3 of { happy_var_3 -> 
	happyIn33
		 (let (e,finfo) = happy_var_3 in (C (happy_var_1 := e),finfo)
	)}}

happyReduce_111 = happySpecReduce_1  25# happyReduction_111
happyReduction_111 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenNumber happy_var_1 _) -> 
	happyIn34
		 ([happy_var_1]
	)}

happyReduce_112 = happySpecReduce_3  25# happyReduction_112
happyReduction_112 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { (TokenNumber happy_var_1 _) -> 
	case happyOut34 happy_x_3 of { happy_var_3 -> 
	happyIn34
		 (happy_var_1:happy_var_3
	)}}

happyReduce_113 = happySpecReduce_1  26# happyReduction_113
happyReduction_113 happy_x_1
	 =  case happyOut36 happy_x_1 of { happy_var_1 -> 
	happyIn35
		 ([happy_var_1]
	)}

happyReduce_114 = happySpecReduce_3  26# happyReduction_114
happyReduction_114 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut36 happy_x_1 of { happy_var_1 -> 
	case happyOut35 happy_x_3 of { happy_var_3 -> 
	happyIn35
		 (happy_var_1:happy_var_3
	)}}

happyReduce_115 = happyReduce 4# 27# happyReduction_115
happyReduction_115 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVar happy_var_1 _) -> 
	happyIn36
		 (EnvConstraint  happy_var_1
	) `HappyStk` happyRest}

happyReduce_116 = happyReduce 4# 27# happyReduction_116
happyReduction_116 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVarCtxt ACtxt happy_var_1 _) -> 
	happyIn36
		 (CtxtConstraint happy_var_1
	) `HappyStk` happyRest}

happyReduce_117 = happyReduce 4# 27# happyReduction_117
happyReduction_117 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVarCtxt Ctxt  happy_var_1 _) -> 
	happyIn36
		 (CtxtConstraint happy_var_1
	) `HappyStk` happyRest}

happyReduce_118 = happyReduce 4# 27# happyReduction_118
happyReduction_118 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TokenMetaVarCtxt TCtxt happy_var_1 _) -> 
	happyIn36
		 (CtxtConstraint happy_var_1
	) `HappyStk` happyRest}

happyReduce_119 = happyReduce 5# 27# happyReduction_119
happyReduction_119 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOut26 happy_x_4 of { happy_var_4 -> 
	happyIn36
		 (let 
                                           (e1,_) = happy_var_2 
                                           (e2,_) = happy_var_4 
                                       in CapConstraint  (e1,e2)
	) `HappyStk` happyRest}}

happyReduce_120 = happyReduce 5# 27# happyReduction_120
happyReduction_120 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut32 happy_x_2 of { happy_var_2 -> 
	case happyOut26 happy_x_4 of { happy_var_4 -> 
	happyIn36
		 (let 
                                           (e1,_) = happy_var_2 
                                           (e2,_) = happy_var_4 
                                       in CapConstraintEnv  (e1,e2)
	) `HappyStk` happyRest}}

happyNewToken action sts stk [] =
	happyDoAction 43# notHappyAtAll action sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = happyDoAction i tk action sts stk tks in
	case tk of {
	TokenVar  happy_dollar_dollar _ -> cont 1#;
	TokenMetaVar happy_dollar_dollar _ -> cont 2#;
	TokenMetaVarCtxt ACtxt happy_dollar_dollar _ -> cont 3#;
	TokenMetaVarCtxt Ctxt  happy_dollar_dollar _ -> cont 4#;
	TokenMetaVarCtxt TCtxt happy_dollar_dollar _ -> cont 5#;
	TokenSymbol   "|" _ -> cont 6#;
	TokenSymbol   "," _ -> cont 7#;
	TokenSymbol   "\\" _ -> cont 8#;
	TokenSymbol   ";" _ -> cont 9#;
	TokenSymbol   "=" _ -> cont 10#;
	TokenSymbol   "/=" _ -> cont 11#;
	TokenSymbol  "==>" _ -> cont 12#;
	TokenSymbol  "." _ -> cont 13#;
	TokenSymbol  "("  _ -> cont 14#;
	TokenSymbol  "{"  _ -> cont 15#;
	TokenSymbol  ")" _ -> cont 16#;
	TokenSymbol  "}" _ -> cont 17#;
	TokenSymbol  "["  _ -> cont 18#;
	TokenSymbol  "]"  _ -> cont 19#;
	TokenSymbol  "*"  _ -> cont 20#;
	TokenSymbol  "+"  _ -> cont 21#;
	TokenSymbol ".l" _ -> cont 22#;
	TokenSymbol ".r" _ -> cont 23#;
	TokenSymbol  "=?="  _ -> cont 24#;
	TokenKeyword "letrec" _ -> cont 25#;
	TokenKeyword "TRANSFORMATIONS" _ -> cont 26#;
	TokenKeyword "in" _ -> cont 27#;
	TokenKeyword "overlap" _ -> cont 28#;
	TokenKeyword "all" _ -> cont 29#;
	TokenKeyword "and" _ -> cont 30#;
	TokenKeyword "HOLE" _ -> cont 31#;
	TokenKeyword "vlet" _ -> cont 32#;
	TokenKeyword "vlift" _ -> cont 33#;
	TokenKeyword "var" _ -> cont 34#;
	TokenKeyword "vlam" _ -> cont 35#;
	TokenKeyword "where" _ -> cont 36#;
	TokenKeyword "except" _ -> cont 37#;
	TokenKeyword "union" _ -> cont 38#;
	TokenKeyword "ignore" _ -> cont 39#;
	TokenKeyword "ANSWER" _ -> cont 40#;
	TokenKeyword "SR" _ -> cont 41#;
	TokenNumber happy_dollar_dollar _ -> cont 42#;
	_ -> happyError' (tk:tks)
	}

happyError_ 43# tk tks = happyError' tks
happyError_ _ tk tks = happyError' (tk:tks)

newtype HappyIdentity a = HappyIdentity a
happyIdentity = HappyIdentity
happyRunIdentity (HappyIdentity a) = a

instance Functor HappyIdentity where
    fmap f (HappyIdentity a) = HappyIdentity (f a)

instance Applicative HappyIdentity where
    pure  = return
    (<*>) = ap
instance Monad HappyIdentity where
    return = HappyIdentity
    (HappyIdentity p) >>= q = q p

happyThen :: () => HappyIdentity a -> (a -> HappyIdentity b) -> HappyIdentity b
happyThen = (>>=)
happyReturn :: () => a -> HappyIdentity a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> HappyIdentity a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [(TokenType)] -> HappyIdentity a
happyError' = HappyIdentity . happyError

parseExpr tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse 0# tks) (\x -> happyReturn (happyOut26 x))

parse tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse 1# tks) (\x -> happyReturn (happyOut22 x))

parseMatchProblem tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse 2# tks) (\x -> happyReturn (happyOut25 x))

parseRules tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse 3# tks) (\x -> happyReturn (happyOut16 x))

parseRulesAndCommands tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse 4# tks) (\x -> happyReturn (happyOut10 x))

parseSRulesAndCommands tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse 5# tks) (\x -> happyReturn (happyOut9 x))

happySeq = happyDontSeq


data Constraint a b c d = EnvConstraint a | CtxtConstraint b | CapConstraint c | CapConstraintEnv d

envcon xs = [Env emptySubstitution x | (EnvConstraint x) <- xs]
ctxtcon xs = [MetaCtxt emptySubstitution (srt x) x | (CtxtConstraint x) <- xs]
capcon xs = [(Left a,b) | (CapConstraint (a,b)) <- xs]
           ++ [(Right $ applyEnvItems a empty,b) | CapConstraintEnv (a,b) <- xs]



data EnvItem a b c = A a | B b | C c
applyEnvItems xs env = 
  env{metaEnvVars = map (Env emptySubstitution) (map fromA $ filter isA xs),
      metaChains  = map fromB $ filter isB xs,
      bindings    = map fromC $ filter isC xs}
 where
  isA (A _) = True
  isA _ = False
  isB (B _) = True
  isB _ = False
  isC (C _) = True
  isC _ = False
  fromA (A x) = x
  fromB (B x) = x
  fromC (C x) = x
srt ('A':_) = ACtxt
srt ('T':_) = TCtxt
srt ('C':_) = Ctxt
srt _ = Ctxt



happyError :: [TokenType] -> a
happyError []     = error $ "parse error: unexpected end of file "
happyError (x:xs) = error $ "parse error before: "
                          ++ (take 200 $ concat ( intersperse " " ( map showToken xs)))  ++ (printMark xs)



parser str =
 let (parseRes,funinfo) = parse $ lexInput str
 in  case (check (parseResToProblem parseRes)) of 
       Just err -> error err
       Nothing -> (parseRes,funinfo)

parseResToProblem (eqs,ctxtcon,envcon,ncc) =
   Problem {                         solution       = []
                                    ,gamma          = gam
                                    ,delta          = Delta {delta1=ctxtcon,delta2=envcon,delta3=ncc,delta4=emptyGamma}
                                    ,fresh          = []
                                    ,functions      = []
                                    ,inputGamma     = gam
                                    ,inputDelta     = Delta {delta1=ctxtcon,delta2=envcon,delta3=ncc,delta4=emptyGamma}
                                    ,constantDelta  = emptyDelta
                                }
  where gam =  Gamma { varLiftEq = []
                     , expressionEq = eqs
                     , environmentEq = []
                     , bindingEq = []
                     } 

parserMatching str =
 let (parseRes,funinfo) = parseMatchProblem $ lexInput str
 in  (parseRes,funinfo)



compactFunInfo :: FunInfo -> FunInfo
compactFunInfo finfo =
 let 
      sorted = sortBy (\(n,arity,spos,bari) (n1,arity1,spos1,bari1) -> compare n n1) finfo
      grouped = groupBy (\(n,arity,spos,bari) (n1,arity1,spos1,bari1) -> n == n1) sorted
      joinGroup group@((n,arity,spos,bari):_) = 
                   let 
                      arities = [a | (_,a,_,_) <- group]
                      spositions = [s | (_,_,s,_) <- group]
                      lspos      = [l | l <- spositions, l /= [1]]
                      bindarities  = [b | (_,_,_,b) <- group]
                      lbindarities = [b | b <- bindarities, b /= []]
                      theArity = if (length (nub arities) /= 1) then
                                      error $ "function symbol '" ++ n ++ "' occurs with different arities"
                                  else arity
                      theSpos  = if null lspos then [1] else
                                  if (length (nub lspos)) == 1 then (head lspos) else 
                                      error $ "function symbol '" ++ n ++ "' occurs with different strict positions"
                      theBindArities = if null lbindarities then [] else
                                        if (length (nub lbindarities)) == 1 then (head lbindarities) else
                                      error $ "function symbol '" ++ n ++ "' occurs with different binder arities"
                         
                   in (n,theArity,theSpos,theBindArities)
 in map joinGroup grouped
isUNION (UNION _ _) = True
isUNION _ = False
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 10 "<command-line>" #-}
# 1 "/usr/include/stdc-predef.h" 1 3 4

# 17 "/usr/include/stdc-predef.h" 3 4























{-# LINE 10 "<command-line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 13 "templates/GenericTemplate.hs" #-}





-- Do not remove this comment. Required to fix CPP parsing when using GCC and a clang-compiled alex.
#if __GLASGOW_HASKELL__ > 706
#define LT(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.<# m)) :: Bool)
#define GTE(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.>=# m)) :: Bool)
#define EQ(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.==# m)) :: Bool)
#else
#define LT(n,m) (n Happy_GHC_Exts.<# m)
#define GTE(n,m) (n Happy_GHC_Exts.>=# m)
#define EQ(n,m) (n Happy_GHC_Exts.==# m)
#endif
{-# LINE 46 "templates/GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Happy_GHC_Exts.Int# Happy_IntList





{-# LINE 67 "templates/GenericTemplate.hs" #-}

{-# LINE 77 "templates/GenericTemplate.hs" #-}

{-# LINE 86 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
        happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
        (happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
        = {- nothing -}


          case action of
                0#           -> {- nothing -}
                                     happyFail i tk st
                -1#          -> {- nothing -}
                                     happyAccept i tk st
                n | LT(n,(0# :: Happy_GHC_Exts.Int#)) -> {- nothing -}

                                                   (happyReduceArr Happy_Data_Array.! rule) i tk st
                                                   where rule = (Happy_GHC_Exts.I# ((Happy_GHC_Exts.negateInt# ((n Happy_GHC_Exts.+# (1# :: Happy_GHC_Exts.Int#))))))
                n                 -> {- nothing -}


                                     happyShift new_state i tk st
                                     where new_state = (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#))
   where off    = indexShortOffAddr happyActOffsets st
         off_i  = (off Happy_GHC_Exts.+# i)
         check  = if GTE(off_i,(0# :: Happy_GHC_Exts.Int#))
                  then EQ(indexShortOffAddr happyCheck off_i, i)
                  else False
         action
          | check     = indexShortOffAddr happyTable off_i
          | otherwise = indexShortOffAddr happyDefActions st


indexShortOffAddr (HappyA# arr) off =
        Happy_GHC_Exts.narrow16Int# i
  where
        i = Happy_GHC_Exts.word2Int# (Happy_GHC_Exts.or# (Happy_GHC_Exts.uncheckedShiftL# high 8#) low)
        high = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr (off' Happy_GHC_Exts.+# 1#)))
        low  = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr off'))
        off' = off Happy_GHC_Exts.*# 2#





data HappyAddr = HappyA# Happy_GHC_Exts.Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 170 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) sts of
         sts1@((HappyCons (st1@(action)) (_))) ->
                let r = fn stk in  -- it doesn't hurt to always seq here...
                happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
          let drop_stk = happyDropStk k stk in
          happyThen1 (fn stk tk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))

happyMonad2Reduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
         let drop_stk = happyDropStk k stk

             off = indexShortOffAddr happyGotoOffsets st1
             off_i = (off Happy_GHC_Exts.+# nt)
             new_state = indexShortOffAddr happyTable off_i



          in
          happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))

happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n Happy_GHC_Exts.-# (1#::Happy_GHC_Exts.Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off = indexShortOffAddr happyGotoOffsets st
         off_i = (off Happy_GHC_Exts.+# nt)
         new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail 0# tk old_st _ stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--      trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
                                                (saved_tok `HappyStk` _ `HappyStk` stk) =
--      trace ("discarding state, depth " ++ show (length stk))  $
        happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
        happyDoAction 0# tk action sts ( (Happy_GHC_Exts.unsafeCoerce# (Happy_GHC_Exts.I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Happy_GHC_Exts.Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--      happySeq = happyDoSeq
-- otherwise it emits
--      happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
