-----------------------------------------------------------------------------
-- |
-- Module      :  LRSX.Interface.DocStrings
-- Copyright   :  (c) D. Sabel, Goethe-University, Frankfurt a.M., Germany
-- License     :  BSD-style 
-- 
-- Maintainer  :  sabel <at> ki.cs.uni-frankfurt.de
--
--  
-- several strings for the command line interface (helptexts)
--
-----------------------------------------------------------------------------
module LRSX.Interface.DocStrings where

-- | the global help text
globalHelp =
 unlines 
    ["Command line interface to the LRSX Unification Tool"
    ,"See http://www.ki.cs.uni-frankfurt.de/research/lrsx for more information."
    ,""
    ,"Usage: lrsx COMMAND [FLAGS] [INPUTFILE]"
    ,""
    ,"Commands"
    ,""
    ,"  unify          Unify the equations in INPUTFILE."
    ,"  "
    ,"  overlap        Compute unifiers and critical pairs "
    ,"                 for the rules and overlap-commands in INPUTFILE."
    ,"                 "
    ,"  help           Help about commands."
    ,""
    ,"Flags "
    ," "
    ,"  are command specific, type"
    ,"  "
    ,"    lrsx COMMAND help "
    ,"    "
    ,"  for an overview of available flags."
    ,"  "
    ,"(c) David Sabel, 2016"
  ]
-- help text for specific commands
commandHelp "overlap"  =

    unlines 
    ["Compute unifiers and critical pairs "
    ,"for the rules and overlap-commands in INPUTFILE."
    ,""
    ,"Usage: lrsx overlap INPUTFILE"
    ,""
    ,"type "
    ,"    lrsx help "
    ,"    "
    ,"  for global help on lrsx"
    ,"  "
    ,"(c) David Sabel, 2016"
  ]

  
commandHelp "unify"  =
 unlines 
    ["Unify equations in INPUTFILE"
    ,""
    ,"Usage: lrsx unify INPUTFILE"
    ,""
    ,"type "
    ,"    lrsx help "
    ,"    "
    ,"  for global help on lrsx"
    ,"  "
    ,"(c) David Sabel, 2016"
  ]

  
    
    
commandHelp _  =
 unlines 
    ["Command not yet implemented"
    ,""
    ,"type "
    ,"    lrsx help "
    ,"    "
    ,"  for global help on lrsx"
    ,"  "
    ,"(c) David Sabel, 2016"
  ]

  
  
  